/**
 * ------------------------------------------------------------------------
 * JA K2 Filter Module for J25 & J3.4
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */
function jak2DisplayExtraFields (moduleid, obj, selected_group) {
	var sOption = obj.getSelected();
	var group = sOption.getProperty('rel');
	var value = sOption.get("value");
	
	var parent = obj.getParent('.ja-k2filter');
	var parentid = parent.id;
	
	$$('#'+parentid+' .exfield').each(function(item){
		magicid = $(item).get('id') .toString();
		if('m'+magicid){		
			if($(item).hasClass('opened')) {
				$(item).removeClass('opened');
				$(item).addClass('closed');
				$('m'+magicid).setStyle('display', 'none');
			} else if($(item).hasClass('closed')) {

			}
		}
	});

	if((value != 0 && group != '') || selected_group) {
		if(group == '') {
			group = selected_group;
		}
		jQuery('#'+parentid).find('.heading-group').each(function() {
			if(this.hasClass('heading-group-'+group)) {
				this.removeClass('ui-accordion-disabled ui-state-disabled');
				if(!this.hasClass('ui-state-active')) {
					var accor = jQuery('#ja-extra-field-accordion-'+moduleid);
					accor.accordion('activate', this);
				}
			} else {
				//clear value of extra fields in group that not associated with selected category
				this.addClass('ui-accordion-disabled ui-state-disabled');
				jaK2Reset(moduleid, jQuery(this).next('.ui-accordion-content'), false);
			}
		});
	} else {
		jQuery('#'+parentid).find('.heading-group').removeClass('ui-accordion-disabled ui-state-disabled');
	}
}

function jaK2Reset(moduleId, container, submitform)
{
	//var form = jQuery('#'+formId);
	if(typeof(container) == 'string') {
		container = jQuery('#'+container);
	}
	//reset input
	container.find('input[type=text], textarea').val('');

	//radio, checkbox
	container.find(':checked').each(function(item){
		jQuery(this).removeAttr('checked');
	});

	//reset magic select
	container.find('.ja-magic-select ul li').each(function(item)
	{
		jQuery(this).removeClass('selected');
	});
	container.find('.ja-magic-select-container').each(function(item)
	{
		jQuery(this).html('');
	});

	// reset depend filter.
	container.find('select').each(function(item)
	{
		if (jQuery(this).attr('multiple') == 'multiple') {
			jQuery(this).val('').chosen("destroy").chosen();
		} else
			jQuery(this).val(jQuery(this).find('option:first-child').val()).chosen("destroy").chosen();
	});
	container.find('input.jak2dependarray, input.jak2dependtxt').val('');

	//reset range slider
	container.find('[name$="_jacheck"]').each(function(el) {
		var sliders = jQuery('#slider_'+this.id.replace('_jacheck', ''));
		if(sliders) {
			var val = this.value.split('|');
			sliders.slider('values', 0, val[0]);
			sliders.slider('values', 1, val[1]);
		}
	});

	//submit form?
	if(submitform) {
		if(container.prop('tagName').toLowerCase() != 'form') {
			var form = container.parents('form');
		} else {
			var form = container;
		}
		var autofilter = form.find('[name="btnSubmit"]').length;
		if(!autofilter) {
			if(typeof(form.submit) == 'function') {
				form.submit();
			}
		}
	}
}

function jaMagicInit(lid, fid) {

	$$('#'+lid+' li').each(function(item){
		if(item.hasClass('selected')) {
			jaMagicAddElement(lid, fid, item.innerHTML, item.getProperty('rel'));
		}
	});

	$$('#'+lid+' li.active').each(function(item){
		item.addEvent('click', function() {
			var id = this.getProperty('rel');
			if(!id) return;
			
			if(this.hasClass('selected')) {
				this.removeClass('selected');
				$(lid+'-'+id).dispose();
			} else {
				this.addClass('selected');
				jaMagicAddElement(lid, fid, this.innerHTML, id);
			}
			var autofilter = $(lid).getProperty('data-autofilter');
			if(autofilter == 1) {
				$(lid).getParent('form').fireEvent('submit');
			}
		});
	    
	});
}

function jaMagicAddElement(lid, fid, label, id) {
	var container = $(lid+'-container');
	var el = new Element('span', {
			id: lid+'-'+id,
		    html: label + '<input type="hidden" name="'+fid+'[]" value="'+id+'" />'
		});
	var elRemove = new Element('span', {
			title: 'Remove',
			'class': 'remove',
			rel: id,
		    html: '',
		    events: {
		        click: function(){
		        	var lid = (this.getParent().id).replace(/^((?:[a-z0-9_]+\-){2}[a-z0-9_]*).*/, '$1');//id format: mg-moduleid-fieldid-value
		        	$$('#'+lid+' li[rel="'+this.getProperty('rel')+'"]').removeClass('selected');
		        	this.getParent().dispose();
		        	//auto search
				    var autofilter = $(lid).getProperty('data-autofilter');
				    if(autofilter == 1) {
				    	$(lid).getParent('form').fireEvent('submit');
				    }
		        }
		    }
		});
	el.grab(elRemove);
	container.grab(el);
}

function jaMagicSelect(controller, lid) {
	controller = $(controller);
	if(controller.hasClass('opened')) {
		controller.removeClass('opened');
		controller.addClass('closed');
		$(lid).setStyle('display', 'none');
	} else {
		controller.removeClass('closed');
		controller.addClass('opened');
		$(lid).setStyle('display', 'block');
	}
}
function jaMagicSelectClose(controller, lid) {
	controller = $(controller);
	controllerparent = $(lid).getParent().getElement('.select');
	if(controllerparent.hasClass('opened')) {
		controllerparent.removeClass('opened');
		controllerparent.addClass('closed');
	} else {
		controllerparent.removeClass('closed');
		controllerparent.addClass('opened');
	}
	$(lid).setStyle('display', 'none');	
}

function jak2AjaxSubmit(form, K2SitePath) {
	//if Container K2 does not exist, submit form to redirect to K2 Filter result page
    if(jQuery('#k2Container').length) {
        jak2AjaxStart();
        jQuery.ajax({
            type: "POST",
            url: jQuery(form).attr('action'),
            data: jQuery(form).serialize(),
            success: function(text){
                jak2AjaxHandle(text, K2SitePath);
            }
        });
    } else {
        jQuery(form).find('input[name="tmpl"]').val('');
        $(form).submit();
    }
}

function jak2AjaxStart() {
    if(!jQuery('#jak2-loading').length) {
        jQuery('body').append('<div id="jak2-loading">Loading</div>');
    }
    jQuery('#jak2-loading').css({'display': 'block'});
}

function jak2GetUrlSharing(form){
	var params = jQuery(form).serialize();
	params = params.replace('task=search&', 'task=shareurl&');
	params = params.replace('&tmpl=component', '');
	jQuery.ajax({
		type: "POST",
		url: jQuery(form).attr('action'),
		data: params,
		success: function(shareurl){
			if(jQuery(form).find('.jak2shareurl a').length){
				jQuery(form).find('.jak2shareurl a').attr('href', shareurl);
			}
		}
	});
}

function jak2AjaxPagination(container, K2SitePath) {
    var pages = container.find('ul.pagination-list li a');
    if(!pages.length) {
        pages = container.find('.k2Pagination ul li a');
    }
    pages.each(function(){
        jQuery(this).click(function(event) {
            event.preventDefault();
            jak2AjaxStart();
            jQuery.ajax({
                type: "GET",
                url: jQuery(this).attr('href'),
                success: function(text){
                    jak2AjaxHandle(text, K2SitePath);
                }
            });
            return false;
        });
    });
}

function jak2Highlight(container, searchword) {
    if(typeof(jQuery.fn.highlight) == 'function' && searchword != undefined) {
        searchword = searchword.replace(/[<>#\\]/, '');
        //remove excluded words
        searchword = searchword.replace(/\-\s*(intitle\:|intext\:|inmetadata\:|inmedia\:)?\s*("[^"]"|[^\s]+)/g,'');
        //remove special keywords
        searchword = searchword.replace(/(intitle\:|intext\:|inmetadata\:|inmedia\:)/g,'');

        var pattern = /(?:"[^"]+"|[^\s]+)/gi;
        var matches = searchword.match(pattern);
        if(matches) {
            for(i=0; i<matches.length; i++) {
                var word = matches[i].replace(/"/g, '');
                if(word != '' && word != 'OR') {
                    container.highlight(word);
                }
            }
        }
    }
}
function jak2AjaxHandle(text, K2SitePath) {
    var container = jQuery('#k2Container');
    var content = jQuery('<div>' + text + '</div>').find('#k2Container');
    if(content.length) {
        container.html(content.html());
        //paging
        jak2AjaxPagination(container, K2SitePath);

        //rating
        container.find('.itemRatingForm a').click(function(event){
            event.preventDefault();
            var itemID = jQuery(this).attr('rel');
            var log = jQuery('#itemRatingLog' + itemID).empty().addClass('formLogLoading');
            var rating = jQuery(this).html();
            jQuery.ajax({
                url: K2SitePath+"index.php?option=com_k2&view=item&task=vote&format=raw&user_rating=" + rating + "&itemID=" + itemID,
                type: 'get',
                success: function(response){
                    log.removeClass('formLogLoading');
                    log.html(response);
                    jQuery.ajax({
                        url: K2SitePath+"index.php?option=com_k2&view=item&task=getVotesPercentage&format=raw&itemID=" + itemID,
                        type: 'get',
                        success: function(percentage){
                            jQuery('#itemCurrentRating' + itemID).css('width', percentage + "%");
                            setTimeout(function(){
                                jQuery.ajax({
                                    url: K2SitePath+"index.php?option=com_k2&view=item&task=getVotesNum&format=raw&itemID=" + itemID,
                                    type: 'get',
                                    success: function(response){
                                        log.html(response);
                                    }
                                });
                            }, 2000);
                        }
                    });
                }
            });
        });

        //highlight search team in result
        jak2Highlight(container, jQuery('.ja-k2filter input[name="searchword"]').val());
    } else {
        container.html('No Item found!');
    }
    jQuery('#jak2-loading').css({'display': 'none'});
	jQuery('html, body').animate({scrollTop: container.offset().top}, 1000);
}

function jaK2ShowDaterange(obj, range) {
    if(jQuery(obj).val() == 'range') {
        jQuery(range).show();
    } else {
        jQuery(range).hide();
    }
}

function createwarning ($obj) {
	if ($obj.parents('.'+$subclass+'').find('.jak2-error').length) {
		$obj.parents('.'+$subclass+'').find('.jak2-error').show();
	} else {
		// create if not exists.
		$obj.parents('.'+$subclass+'').find('.group-label').first().after('<div class="jak2-error">'+$required_warning+'</div>');
	}
}

function checkrequired(params, mid) {
	if (params == 0) return true;
	$form = jQuery('#'+mid);
	var $mid = mid.replace('jak2filter-form-','');
	if (params == 1) {
		// at least 1 field must chosen.
		$input = $form.find('input[type="text"], textare, select, input[type="radio"], input[type="checkbox"], .ja-magic-select-container, input[name$="jacheck"]');
		$check = false;
		$input.each(function(){
			$obj = jQuery(this);
			if ($obj.attr('type') == 'text') {
				if (jQuery(this).val() != '') $check=true;
				if ($obj.parents('.'+$subclass+'').find('select').attr('multiple') == 'multiple') $check=false; //reset check if select multipe.
			}
			if ($obj.attr('type') == 'hidden') {
				if ($obj.val() != $obj.prev().val()) $check=true;
			}
			if ($obj.prop("tagName") == 'SELECT') {
				// select type
				if ($obj[0].selectedIndex !== 0 && $obj[0].selectedIndex !== -1) $check=true;
			}
			if ($obj.attr('type') == 'checkbox' || $obj.attr('type') == 'radio')
				if ($obj.is(':checked') == true) $check=true;
			
			if ($obj.hasClass('ja-magic-select-container')) {
				$input = $obj.find('input[type="hidden"]');
				if ($input.length!==0) $check=true;
			}
			if ($check==true) return false; // if at least 1 had value then we stop the each
		});
		if ($check == false) {
			$form.find('.onewarning').show();
		} else {
			$form.find('.onewarning').hide();
		}
		return $check;
	} else {
		// user defined chosen.
		$check = [];
		for (i=0;i<params.length;i++) {
			$obj = $form.find('input[name="'+params[i]+'_to"], input[name="'+params[i]+'_from"], input[name="'+params[i]+'"], input[name="'+params[i]+'_txt"], input[name="'+params[i]+'[]"], select[name="'+params[i]+'_txt"], select[name="'+params[i]+'"], select[name="'+params[i]+'[]"], textarea[name="'+params[i]+'"], div#mg-'+$mid+'-'+params[i]+'-container');
			if ($obj.length == 0) continue; // continue if the field does not exists.
			$warning = false;
		
			if ($obj.attr('type') == 'text') {
				//text field, date field.
				if ($obj.length > 1) {
					if ($obj.eq(0).val() == '' && $obj.eq(1).val() == '') {
						$check.push(false);
						$warning = true;
					}
				} else {
					if ($obj.val() == '') {
						$check.push(false);
						$warning = true;
					}
				}
			}
		
			if ($obj.attr('type') == 'hidden') {
				// jadepend field.
				if ($obj.val() == '') {
					$check.push(false);
					$warning = true;
				}
			}
		
			if ($obj.length > 1) {
				// checkbox, radio.
				if ($obj.eq(0).attr('type') == 'checkbox' || $obj.eq(0).attr('type') == 'radio') {
					multiboxcheck = false;
					$obj.each(function(i, el){
						if (multiboxcheck == false)
							multiboxcheck = el.checked;
					});
					$check.push(multiboxcheck);
					$warning = multiboxcheck == false ? true : false;
				}
			}

			if ($obj.prop("tagName") == 'SELECT') {
				// select type
				if ($obj.attr('multiple') == 'multiple') {
					// multiple
					if (!$obj.find('option:selected').length) {
						$check.push(false);
						$warning = true;
					}
				} else {
					// single
					if ($obj[0].selectedIndex === 0) { // single & multip select.
						$check.push(false);
						$warning = true;
						// should check for date range here then return true if we put all the field.
					}
				}
				
			
				// check for select type with date range.
			}

			if ($obj.prev().hasClass('ui-slider')) {
				// slider type.
				if ($obj.val() == $obj.next().val()) {
					$check.push(false);
					$warning = true;
				}
			}

			// we find magic select seperate.
			if ($obj.hasClass('ja-magic-select-container')) {
				$input = $obj.find('input[type="hidden"]');
				if ($input.length===0) {
					$check.push(false);
					$warning = true;
				}
			}

			if ($warning===true) {
				// return warning here.
				createwarning($obj);
			} else {
				// hide warning if form ok.
				$obj.parents('.'+$subclass+'').find('.jak2-error').remove();
			}
		}
		for (i=0;i<$check.length;i++) {
			if ($check[i] == false) {
				return false;
			}
		}
		return true;
	}
}